<?php

/**
 * Export all Custom Post Types.
 *
 * @package CPT
 * @subpackage Export
 * @author Andrey Koptevich
 * @since 1.0.0
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

function exportAllTypesToYaml()
{
    require_once( dirname(__FILE__, 2) . '/vendor/autoload.php' );
    require_once( dirname(__FILE__, 2) . '/Model/CPTGenerator.php' );

    $generator = new CPTGenerator();
    $yamlStructure = $generator->generate();

    $yaml = $generator->annotations . \Symfony\Component\Yaml\Yaml::dump($yamlStructure, 9);
    $yaml = str_replace("'(1..*)'", "(1..*)", str_replace("'~'", "~", $yaml));
    ?>

    <br>
    <form action="" method="post">
        <input type="submit" name="submit" value="Export all types"><br>
        <h2>Preview area:</h2>
        <textarea name="preview_area" id="preview_area_id" rows="40" cols="120"><?=$yaml?></textarea>
    </form>

    <?php
}

function checkSubmitAllData()
{
    $uploadsPath = dirname(__FILE__, 2) . '/schemas/schema.yaml';

    if(isset($_POST["submit"])) {
        if (isset($_POST["preview_area"])) {
            $yml = $_POST["preview_area"];
            file_put_contents($uploadsPath, $yml);
            ?>
            <h2><p align="center">File was saved in <?=$uploadsPath?></p></h2>
            <?php
        }
    }
}

add_action( 'init', 'checkSubmitAllData' );
