<?php

/**
 * Export Custom Post Types.
 *
 * @package CPT
 * @subpackage Export
 * @author Andrey Koptevich
 * @since 1.0.0
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

require_once( dirname(__FILE__, 2) . '/vendor/autoload.php' );
require_once( dirname(__FILE__, 2) . '/Model/CPTGenerator.php' );

function exportCustomPostTypesToYaml()
{
    $generator = new CPTGenerator();
    $allPostTypes = $generator->getAllPostTypes();
    $selected = true;
    ?>

    <br>
    <form action="" method="post">
        <select size="20" multiple name="select">
            <option disabled>List of all post types:</option>
            <?php
            foreach ($allPostTypes as $postType) { ?>
            <option <?php if ($selected) { echo "selected"; $selected = false; }?> value="<?=$postType?>"><?=$postType?></option>
            <?php } ?>
        </select>
        <br>
        <input type="submit" name="submitSelect" value="Export post type"><br>
    </form>

    <?php
}

function checkSubmitCustomPostData()
{
    $uploadsPath = dirname(__FILE__, 2) . '/schemas/schema.yaml';

    if (isset($_POST["submitSelect"])) {
        if (isset($_POST["select"])) {
            $typePost = $_POST["select"];
            $generator = new CPTGenerator();
            $yamlStructure = $generator->generate($typePost);
            $yaml = $generator->annotations . \Symfony\Component\Yaml\Yaml::dump($yamlStructure, 9);
            $yaml = str_replace("'(1..*)'", "(1..*)", str_replace("'~'", "~", $yaml));
            file_put_contents(dirname(__FILE__, 2) . '/schemas/schema.yaml', $yaml);
            ?>
            <h2><p align="center">File was saved in <?=$uploadsPath?></p></h2>
            <?php
        }
    }
}

add_action( 'init', 'checkSubmitCustomPostData' );
